const { ccclass, property } = cc._decorator

@ccclass
export default class HeroPreview extends cc.Component {
    private skeleton:sp.Skeleton = null;
    private url:string = "";

    onLoad():void{
        if(this.skeleton == null){
            let node = new cc.Node("body");
            node.zIndex = 1;
            this.node.addChild(node);
            node.position = cc.Vec2.ZERO;
            this.skeleton = node.addComponent(sp.Skeleton);
        }
    }

    start(){
        let act = cc.fadeIn(0.5);
        this.node.opacity = 0;
        this.node.runAction(act);
    }

    public setUrl(url: string):void{
        this.url = url;
        this.loadUrl(this.url);
    }
    protected loadUrl(url:string):void{
        cc.loader.loadRes(url, sp.SkeletonData, null,this.onLoaded.bind(this));
    }

    private onLoaded(err:Error, res:sp.SkeletonData):void{
        if(err){
            console.error(` 资源加载失败：err =  ${err.message}`);
        }
        else{
            this.skeleton.skeletonData = res;
            this.onLoadPlay();
        }
    }
    private onLoadPlay(){
        this.skeleton.setAnimation(0, "Idle", true);
    }
}