import HeroPreview from "./HeroPreview";

const { ccclass, property } = cc._decorator

/**
 * 测试Spine的透明度变化BUG    (测试会发现 Spine第一创建展示的前几帧没有爱父节点的透明度影响，结果表现为亮一下，再跟着父节点的透明度变化)    WEB正常  NATIVE异常
 */
@ccclass
export default class WelcomeScene extends cc.Component {
    @property(cc.Node) n_content:cc.Node = null;
    @property(cc.Prefab) heroPrefab:cc.Prefab = null;

    private urlList:Array<string> = [
        "14001/14001",
        "15001/15001",
        "21001/21001",
    ]
    private posList:Array<cc.Vec2> = [
        cc.v2(-200,0),
        cc.v2(0,0),
        cc.v2(200,0),
    ]

    /**
     * 点击测试，测试会发现 原Spine的缩放属性及位置属性都被重置了
     */
    onTestMaterialClick(){
        if(this.n_content.childrenCount > 0){
            return;
        }
        this.urlList.forEach((url,index)=>{
            let node = cc.instantiate(this.heroPrefab);
            node.setPosition(this.posList[index]);
            this.n_content.addChild(node);
            node.getComponent(HeroPreview).setUrl(url);
        })
    }
    onRemove(){
        this.n_content.destroyAllChildren();
    }
}